﻿using Infragistics.Windows.Reporting;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataGridReporting
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.XamDataGrid1.DataSource = CreateTable(15, 150).DefaultView;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            // Create report and add visual to print
            Report reportObj = new Report();

            //scale to fit all columns on the page? default spreads across pages mosaic etc.  -- Scale seems to make first page small if there is a groupby
            reportObj.ReportSettings.HorizontalPaginationMode = HorizontalPaginationMode.Scale;
 
            //make column headers repeat every page
            reportObj.ReportSettings.RepeatType = RepeatType.LevelBreak;  //PageBreak?
             

            // Create section with chart
            EmbeddedVisualReportSection section = new EmbeddedVisualReportSection(XamDataGrid1);
            reportObj.Sections.Add(section);
 

            // Put report to preview control
            XamReportPreview1.GeneratePreview(reportObj, false, false);

            tbiPreview.IsSelected = true;
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                d.Columns.Add(new DataColumn("Column " + i, typeof(int)));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    row["Column " + j] = 10;
                }

                d.Rows.Add(row);
            }
            return d;
        }

        private void XamDataGrid1_InitializeRecord(object sender, Infragistics.Windows.DataPresenter.Events.InitializeRecordEventArgs e)
        {
            if (e.Record.NestingDepth == 0)
            {

                e.Record.IsExpanded = true;

            }
        }

    }
}
